libzypp: zypp::UserRequestException Class Reference

libzypp 17.25.10

Public Types | Public Member Functions | Protected Member Functions | Private Attributes | List of all members
zypp::UserRequestException Class Reference

Base for exceptions caused by explicit user request. More...

`#include <UserRequestException.h>`

Inheritance diagram for zypp::UserRequestException:
[legend]

## Public Types
enum | Kind { UNSPECIFIED , IGNORE , SKIP , RETRY , ABORT }
Public Types inherited from zypp::Exception
typedef exception_detail::CodeLocation | CodeLocation
typedef std::list< std::string > | History
typedef History::const_iterator | HistoryIterator
typedef History::size_type | HistorySize

## Public Member Functions
| UserRequestException (const std::string &msg_r=std::string())
| UserRequestException (const std::string &msg_r, const Exception &history_r)
| UserRequestException (Kind kind_r, const std::string &msg_r=std::string())
| UserRequestException (Kind kind_r, const std::string &msg_r, const Exception &history_r)
Kind | kind () const
Public Member Functions inherited from zypp::Exception
| Exception ()
| Default ctor. More...
| Exception (const std::string &msg_r)
| Ctor taking a message. More...
| Exception (std::string &&msg_r)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
| Exception (const std::string &msg_r, const Exception &history_r)
| Ctor taking a message and an exception to remember as history. More...
| Exception (std::string &&msg_r, const Exception &history_r)
| Exception (const std::string &msg_r, Exception &&history_r)
| Exception (std::string &&msg_r, Exception &&history_r)
virtual | ~Exception () throw ()
| Dtor. More...
const CodeLocation & | where () const
| Return CodeLocation. More...
void | relocate (const CodeLocation &where_r) const
| Exchange location on rethrow. More...
const std::string & | msg () const
| Return the message string provided to the ctor. More...
std::string | asString () const
| Error message provided by dumpOn as string. More...
std::string | asUserString () const
| Translated error message as string suitable for the user. More...
void | remember (const Exception &old_r)
| Store an other Exception as history. More...
void | remember (Exception &&old_r)
void | addHistory (const std::string &msg_r)
| Add some message text to the history. More...
void | addHistory (std::string &&msg_r)
template<class TContainer >
void | addToHistory (const TContainer &msgc_r)
| addHistory from string container types (oldest first) More...
template<class TContainer >
void | moveToHistory (TContainer &&msgc_r)
| addHistory from string container types (oldest first) moving More...
HistoryIterator | historyBegin () const
| Iterator pointing to the most recent message. More...
HistoryIterator | historyEnd () const
| Iterator pointing behind the last message. More...
bool | historyEmpty () const
| Whether the history list is empty. More...
HistorySize | historySize () const
| The size of the history list. More...
std::string | historyAsString () const
| The history as string. More...
std::string | asUserHistory () const
| A single (multiline) string composed of asUserString and historyAsString. More...

## Protected Member Functions
virtual std::ostream & | dumpOn (std::ostream &str) const
| Overload this to print a proper error message. More...
Protected Member Functions inherited from zypp::Exception

## Private Attributes
Kind | _kind

## Additional Inherited Members
Static Public Member Functions inherited from zypp::Exception
static std::string | strErrno (int errno_r)
| Make a string from errno_r. More...
static std::string | strErrno (int errno_r, const std::string &msg_r)
| Make a string from errno_r and msg_r. More...
static std::string | strErrno (int errno_r, std::string &&msg_r)
static void | log (const Exception &excpt_r, const CodeLocation &where_r, const char *const prefix_r)
| Drop a logline on throw, catch or rethrow. More...
static void | log (const char *typename_r, const CodeLocation &where_r, const char *const prefix_r)
| \overrload for not-Exception types thrown via ZYPP_THROW More...
Related Functions inherited from zypp::Exception
std::ostream & | operator<< (std::ostream &str, const Exception &obj)
| Stream output. More...

## Detailed Description

Base for exceptions caused by explicit user request.

Use the derived convenience classes to throw exceptions of a certain kind.

ProgressData ticks( makeProgressData( input_r ) );
ticks.sendTo( fnc_r );
ticks.toMin(); // start sending min (0)
iostr::EachLine line( input_r );
for( ; line; line.next() )
{
// process the line
if ( ! ticks.set( input_r.stream().tellg() ) )
ZYPP_THROW( AbortRequestException( "" ) );
}
ZYPP_THROW
#define ZYPP_THROW(EXCPT)
Drops a logline and throws the Exception.
Definition: Exception.h:392
zypp::makeProgressData
ProgressData makeProgressData(const InputStream &input_r)
Definition: ProgressData.cc:117
// either this way
catch ( const AbortRequestException & excpt_r )
{
...
}
// or that
catch ( const UserRequestException & excpt_r )
{
switch ( excpt_r.kind() )
{
case UserRequestException::ABORT:
...
break;
}
}
zypp::UserRequestException::ABORT
@ ABORT
Definition: UserRequestException.h:67
zypp::UserRequestException::UserRequestException
UserRequestException(const std::string &msg_r=std::string())
Definition: UserRequestException.cc:28

Definition at line 64 of file UserRequestException.h.

## Member Enumeration Documentation

## ◆ Kind

enum zypp::UserRequestException::Kind

Enumerator
UNSPECIFIED |
IGNORE |
SKIP |
RETRY |
ABORT |

Definition at line 67 of file UserRequestException.h.

## Constructor & Destructor Documentation

## ◆ UserRequestException() [1/4]

zypp::UserRequestException::UserRequestException | ( | const std::string & | msg_r = `std::string()` | ) |
| explicit

Definition at line 28 of file UserRequestException.cc.

## ◆ UserRequestException() [2/4]

zypp::UserRequestException::UserRequestException | ( | const std::string & | msg_r,
|  | const Exception & | history_r
| ) |  |

Definition at line 32 of file UserRequestException.cc.

## ◆ UserRequestException() [3/4]

zypp::UserRequestException::UserRequestException | ( | Kind | kind_r,
|  | const std::string & | msg_r = `std::string()`
| ) |  |
| explicit

Definition at line 36 of file UserRequestException.cc.

## ◆ UserRequestException() [4/4]

zypp::UserRequestException::UserRequestException | ( | Kind | kind_r,
|  | const std::string & | msg_r,
|  | const Exception & | history_r
| ) |  |

Definition at line 40 of file UserRequestException.cc.

## Member Function Documentation

## ◆ kind()

Kind zypp::UserRequestException::kind | ( |  | ) | const
| inline

Definition at line 76 of file UserRequestException.h.

## ◆ dumpOn()

std::ostream & zypp::UserRequestException::dumpOn | ( | std::ostream & | str | ) | const
| protectedvirtual

Overload this to print a proper error message.

Reimplemented from zypp::Exception.

Definition at line 49 of file UserRequestException.cc.

## Member Data Documentation

## ◆ _kind

Kind zypp::UserRequestException::_kind
| private

Definition at line 81 of file UserRequestException.h.

The documentation for this class was generated from the following files:

- zypp/base/UserRequestException.h
- zypp/base/UserRequestException.cc